import { BrowserModule } from '@angular/platform-browser';
import { FormsModule } from '@angular/forms';
import { DatePipe } from '@angular/common';
import { NgxPaginationModule } from 'ngx-pagination';
import { Injectable, Component, EventEmitter, Output, Input, NgModule, CUSTOM_ELEMENTS_SCHEMA, defineInjectable } from '@angular/core';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class OmnipresentWebLibService {
    constructor() { }
}
OmnipresentWebLibService.decorators = [
    { type: Injectable, args: [{
                providedIn: 'root'
            },] }
];
/** @nocollapse */
OmnipresentWebLibService.ctorParameters = () => [];
/** @nocollapse */ OmnipresentWebLibService.ngInjectableDef = defineInjectable({ factory: function OmnipresentWebLibService_Factory() { return new OmnipresentWebLibService(); }, token: OmnipresentWebLibService, providedIn: "root" });

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class OmnipresentWebLibComponent {
    constructor() { }
    /**
     * @return {?}
     */
    ngOnInit() {
    }
}
OmnipresentWebLibComponent.decorators = [
    { type: Component, args: [{
                selector: 'omnipresent-web-omnipresent-web-lib',
                template: `
    <p>
      omnipresent-web-lib works!
    </p>
  `
            }] }
];
/** @nocollapse */
OmnipresentWebLibComponent.ctorParameters = () => [];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class User {
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class LoginComponent {
    constructor() {
        this.emailPassword = true;
        this.google = true;
        this.twitter = true;
        this.googleEventEmitter = new EventEmitter();
        this.twitterEventEmitter = new EventEmitter();
        this.emailEventEmitter = new EventEmitter();
    }
    /**
     * @return {?}
     */
    ngOnInit() {
        this.user = new User();
    }
    /**
     * @return {?}
     */
    loginWithGoogle() {
        this.googleEventEmitter.emit(true);
    }
    /**
     * @return {?}
     */
    loginWithTwitter() {
        this.twitterEventEmitter.emit(true);
    }
    /**
     * @return {?}
     */
    loginWithEmail() {
        this.emailEventEmitter.emit(this.user);
    }
}
LoginComponent.decorators = [
    { type: Component, args: [{
                selector: 'omnipresent-web-login',
                template: "<div class=\"login\">\n    <div class=\"email-password\" *ngIf=\"emailPassword\">\n        <input [(ngModel)]=\"user.email\" type=\"text\" placeholder=\"Email\" #userEmail required autofocus>\n        <input [(ngModel)]=\"user.password\" type=\"password\" placeholder=\"Password\" #userPassword required>\n        <button (click)=\"loginWithEmail()\">Login</button>\n        <div class=\"divider\">\n            <div class=\"bar\"></div>\n            <span class=\"login-or\">OR</span>\n            <div class=\"bar\"></div>\n        </div>\n    </div>\n    <button *ngIf=\"twitter\" class=\"register-button twitter\" (click)=\"loginWithTwitter()\">\n      <i class=\"fab fa-twitter\"></i>\n      <span>Login with Twitter</span>\n    </button>\n    <button *ngIf=\"google\" class=\"register-button google\" (click)=\"loginWithGoogle()\">\n      <i class=\"fab fa-google\"></i>\n      <span>Login with Google</span>\n    </button>\n</div>\n",
                styles: [".login{text-align:center;display:-ms-grid;display:grid;margin:auto;max-width:400px}.twitter{background-color:#60b5f0}.google{background-color:#db3236}i{margin-right:10px}.divider{display:flex;justify-content:center;margin:20px}.divider .bar{border-bottom:2px solid #2c3e50;margin:5px;width:35%}.email-password{text-align:center;display:-ms-grid;display:grid;margin:auto;width:100%}"]
            }] }
];
/** @nocollapse */
LoginComponent.ctorParameters = () => [];
LoginComponent.propDecorators = {
    emailPassword: [{ type: Input }],
    google: [{ type: Input }],
    twitter: [{ type: Input }],
    googleEventEmitter: [{ type: Output }],
    twitterEventEmitter: [{ type: Output }],
    emailEventEmitter: [{ type: Output }]
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class ViewImageComponent {
    constructor() {
        this.weekIms = [];
        this.counter1 = 0;
        this.show = false;
    }
    /**
     * @return {?}
     */
    ngOnInit() {
        this.picterno = 0;
    }
    /**
     * @return {?}
     */
    ngDoCheck() {
        if (this.data) {
            this.counter1++;
            if (this.counter1 == 1) {
                this.assignImages();
            }
        }
        else {
            this.images = [];
        }
    }
    /**
     * @return {?}
     */
    OnRight() {
        if (this.picterno + 8 < this.data.length) {
            this.picterno += 8;
            this.assignImages();
        }
    }
    /**
     * @return {?}
     */
    OnLeft() {
        if (this.picterno - 8 > -1) {
            this.picterno -= 8;
            this.assignImages();
        }
    }
    /**
     * @return {?}
     */
    assignImages() {
        /** @type {?} */
        var tempImg = [];
        for (let i = 0; i < 8; i++) {
            tempImg.push(this.data[i + this.picterno]);
            this.images = tempImg;
        }
    }
    /**
     * @param {?} imageno
     * @return {?}
     */
    clickImage(imageno) {
        this.assignImages();
        this.show = true;
        this.selectedImage = this.images.indexOf(this.imageno);
        this.mainImage = this.imageno;
    }
    /**
     * @return {?}
     */
    closeImage() {
        this.show = false;
    }
    /**
     * @return {?}
     */
    next() {
        if (this.selectedImage < this.images.length - 1) {
            this.selectedImage += 1;
            this.mainImage = this.images[this.selectedImage];
        }
    }
    /**
     * @return {?}
     */
    prev() {
        if (this.selectedImage > -1) {
            this.selectedImage -= 1;
            this.mainImage = this.images[this.selectedImage];
        }
    }
}
ViewImageComponent.decorators = [
    { type: Component, args: [{
                selector: 'OIV-view-image',
                template: "\n<div class=\"container\">\n  <div class=\"view\" *ngFor=\"let image of images\">\n    <img class=\"main\" [src]=\"image\" (click)=\"clickImage(this.imageno = image)\">\n  </div>\n</div>\n<div id=\"myModal\" class=\"modal\" *ngIf=\"show\">\n  <div class=\"modal-content\">\n    <span class=\"close\" (click)=\"closeImage()\">&times;</span>\n    <img [src]=\"mainImage\" class=\"main1\">\n    <div class=\"modalcontainer\">\n        <button type=\"button\" class=\"btns\" (click)=\"prev()\">prev</button>\n\n        <button type=\"button\" class=\"btns\" (click)=\"next()\" >next</button>\n    </div>\n  </div>\n</div>\n<div class=\"buttoncontainer\">\n    <button type=\"button\" class=\"btns\" (click)=\"OnLeft()\" >prev</button>\n    <button type=\"button\" class=\"btns\" (click)=\"OnRight()\">next</button>\n</div>\n",
                styles: [".icons{opacity:.9;z-index:-1}.main1{-o-object-fit:contain;object-fit:contain;max-width:80%;max-height:80%;margin:auto}.main{max-width:100%;opacity:1;box-shadow:0 8px 16px rgba(black,.45);justify-content:space-between}.main:hover{max-width:100%;opacity:.2}.row{display:flex;border:5px solid #000}.container{display:-ms-grid;display:grid;-ms-grid-columns:auto auto auto auto;grid-template-columns:auto auto auto auto;-ms-grid-rows:auto auto;grid-template-rows:auto auto;grid-gap:50px;background-color:rgba(255,255,255,.1);height:98%;margin-top:10%}.modalcontainer{display:-ms-grid;display:grid;-ms-grid-columns:auto auto auto auto;grid-template-columns:auto auto auto auto;grid-gap:50px;margin-bottom:1%;position:fixed;bottom:25%;right:30%}.buttoncontainer{display:-ms-grid;display:grid;-ms-grid-columns:auto auto auto auto;grid-template-columns:auto auto auto auto;grid-gap:50px;position:fixed;bottom:1%;right:30%}.container>div{background-color:rgba(255,255,255,.8);text-align:center;width:100%;font-size:30px}.mainDisplay{background-color:rgba(255,255,255,.2);padding:10px;width:98%;box-shadow:5px 10px 8px #888}.view{background-color:rgba(255,255,255,.7);box-shadow:5px 10px 8px #888}.modal{display:block;position:fixed;z-index:1;left:0;top:0;width:100%;height:100%;overflow:auto;background-color:rgba(0,0,0,.4)}.modal-content{-o-object-fit:cover;object-fit:cover;background-color:#fefefe;margin-top:5%;margin-left:10%;padding:20px;border:1px solid #888;width:80%;height:80%}.close{color:#aaa;float:right;font-size:28px;font-weight:700}.close:focus,.close:hover{color:#000;text-decoration:none;cursor:pointer}.btns{border-radius:4px;width:50px;height:50px}@media (max-width:400px){.container{display:list-item;-ms-grid-columns:100%;grid-template-columns:100%;-ms-grid-rows:100%;grid-template-rows:100%;grid-gap:10px;padding:10px}}"]
            }] }
];
/** @nocollapse */
ViewImageComponent.ctorParameters = () => [];
ViewImageComponent.propDecorators = {
    data: [{ type: Input }]
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class TableComponent {
    constructor() {
        this.color = 'rgb(135,206,235)';
        this.p = 1;
        this.pageChanged = new EventEmitter();
        this.rowClicked = new EventEmitter();
    }
    /**
     * @return {?}
     */
    ngOnInit() {
    }
    /**
     * @return {?}
     */
    ngDoCheck() {
        this.setDataKeys();
    }
    /**
     * @param {?} i
     * @return {?}
     */
    getColor(i) {
        /** @type {?} */
        let lighterColor = this.color.replace(')', ', 0.5)');
        if (i % 2 === 0 && i !== 0) {
            i = 'odd';
        }
        if (this.data && (this.data.length - 1 === i)) {
            i = 'last';
        }
        switch (i) {
            case i = 0: return this.color;
            case i = 'odd': return this.color;
        }
        return lighterColor;
    }
    /**
     * @return {?}
     */
    setDataKeys() {
        if (this.data) {
            this.dataKeys = Object.keys(this.data[0]);
        }
        else if (this.page) {
            this.dataKeys = Object.keys(this.page.content[0]);
        }
        else {
            this.dataKeys = [];
        }
    }
    /**
     * @param {?} item
     * @return {?}
     */
    rowclicked(item) {
        this.rowClicked.emit(item);
        console.log(item);
    }
}
TableComponent.decorators = [
    { type: Component, args: [{
                selector: 'tables-table',
                template: "<div class=\"table-content\">\n  <h2 class=\"title\">{{header}}</h2>\n  <table *ngIf=\"data\">\n      <thead>\n       <tr class=\"table-row table-header\">\n          <th  *ngFor=\"let header of headers\">{{header}}</th>\n      </tr>\n      </thead>\n      <tbody>\n       <tr class=\"data-row\" *ngFor=\"let item of data; let i =index\"  [ngStyle]=\"{'background-color':getColor(i)}\" (click)=\"rowclicked(item)\">\n        <td *ngFor=\"let item of dataKeys\" [title]='item'>\n          <tables-data-field [data]=\"data[i][item]\"></tables-data-field>\n        </td>\n\n      </tr>\n    </tbody>\n  </table>\n    <table *ngIf=\"page\">\n      <thead>\n      <tr class=\"table-row table-header\">\n        <th  *ngFor=\"let header of headers\">{{header}}</th>\n    </tr>\n  </thead>\n  <tbody>\n      <tr class=\"data-row\" *ngFor=\"let item of page.content | paginate: {\n                                    itemsPerPage: page.pageable.pageSize,\n                                    currentPage: p,\n                                    totalItems:page.totalElements\n                                    };\n                                    let i =index\"  [ngStyle]=\"{'background-color':getColor(i)}\" (click)=\"rowclicked(item)\">\n      <td class=\"rowCont\" *ngFor=\"let item of dataKeys\" [title]='item'>\n        <tables-data-field [data]=\"page.content[i][item]\"></tables-data-field>\n      </td>\n\n    </tr>\n  </tbody>\n  </table>\n  <div class=\"flexbox\"></div>\n  <pagination-controls   class=\"ngx-pagination\"\n                        (pageChange)=\"pageChanged.emit($event); p=$event\"\n                        directionLinks=\"true\"\n                        autoHide=\"true\"\n                        responsive=\"true\"\n                        previousLabel=\"Previous\"\n                        nextLabel=\"Next\"\n                        screenReaderPaginationLabel=\"Pagination\"\n                        screenReaderPageLabel=\"page\"\n                        screenReaderCurrentLabel=\"You're on page\"\n  ></pagination-controls>\n</div>\n\n\n",
                styles: [".title{text-align:center}table{border-collapse:collapse;width:100%}td,th{text-align:center;padding:8px}.button-style{background:0 0;border:1px solid #61a3e5;border-radius:21px;padding:7px 40px 7px 20px;color:#61a3e5;font-size:17px;cursor:pointer;transition:.3s}.flex-container{display:flex;justify-content:center}.flex-container>div{background-color:rgba(0,0,0,0);padding:20px;font-size:30px}.pagControls{right:1500px}.flexbox{margin:auto;align-self:center;background-color:red;display:flex;justify-content:center;width:200%}/deep/ .ngx-pagination{padding:0;text-align:center}@media (max-width:415px){table{width:100%}table,tbody,td,th,thead,tr{display:block;font-size:12px}thead tr{position:absolute;top:-9999px;left:-9999px}th{font-style:italic}tr{border:1px solid #ccc}td{border:none;border-bottom:1px solid #eee;position:relative;padding-left:50%}td:before{position:absolute;top:6px;left:6px;width:45%;padding-right:10px;white-space:nowrap;content:attr(title);color:#000;font-weight:700}}"]
            }] }
];
/** @nocollapse */
TableComponent.ctorParameters = () => [];
TableComponent.propDecorators = {
    header: [{ type: Input }],
    headers: [{ type: Input }],
    data: [{ type: Input }],
    page: [{ type: Input }],
    color: [{ type: Input }],
    pageChanged: [{ type: Output }],
    rowClicked: [{ type: Output }]
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class ModalComponent {
    constructor() { }
    /**
     * @return {?}
     */
    ngOnInit() {
    }
    /**
     * @return {?}
     */
    exit() {
        this.modalOpen = !this.modalOpen;
        console.log('modal closed');
    }
}
ModalComponent.decorators = [
    { type: Component, args: [{
                selector: 'omnipresent-web-modal',
                template: "<div [ngClass]=\"modalOpen ? 'live' : 'none'\" id=\"modal-container\">\n  <div  class=\"modal-background\">\n    <div class=\"modal\">\n      <span class=\"right-side\" (click)=\"exit()\"><i class=\"fas fa-times\"></i></span>\n      <ng-content></ng-content>\n  </div>\n</div>\n",
                styles: [".right-side{text-align:right;margin:20px}#modal-container{position:fixed;display:table;height:100%;width:100%;top:0;left:0;-webkit-transform:scale(0);transform:scale(0);z-index:1}#modal-container.live{-webkit-transform:scale(1);transform:scale(1)}#modal-container.live .modal-background{background:#000;-webkit-animation:.5s cubic-bezier(.165,.84,.44,1) forwards fadeIn;animation:.5s cubic-bezier(.165,.84,.44,1) forwards fadeIn}#modal-container.live .modal-background .modal{opacity:0;-webkit-animation:.5s cubic-bezier(.165,.84,.44,1) forwards scaleUp;animation:.5s cubic-bezier(.165,.84,.44,1) forwards scaleUp}#modal-container.live+.content{-webkit-animation:.5s cubic-bezier(.165,.84,.44,1) forwards scaleBack;animation:.5s cubic-bezier(.165,.84,.44,1) forwards scaleBack}#modal-container.live.out{-webkit-animation:0s linear .5s forwards quickScaleDown;animation:0s linear .5s forwards quickScaleDown}#modal-container.live.out .modal-background{-webkit-animation:.5s cubic-bezier(.165,.84,.44,1) forwards fadeOut;animation:.5s cubic-bezier(.165,.84,.44,1) forwards fadeOut}#modal-container.live.out .modal-background .modal{-webkit-animation:.5s cubic-bezier(.165,.84,.44,1) forwards scaleDown;animation:.5s cubic-bezier(.165,.84,.44,1) forwards scaleDown}#modal-container.live.out+.content{-webkit-animation:.5s cubic-bezier(.165,.84,.44,1) forwards scaleForward;animation:.5s cubic-bezier(.165,.84,.44,1) forwards scaleForward}#modal-container .modal-background{display:table-cell;background:rgba(0,0,0,.8);text-align:center;vertical-align:middle}#modal-container .modal-background .modal{background:#fff;padding:50px;display:inline-block;border-radius:3px;font-weight:300;position:relative;display:-ms-inline-grid;display:inline-grid}#modal-container .modal-background .modal h2{font-size:25px;line-height:25px;margin-bottom:15px}#modal-container .modal-background .modal p{font-size:18px;line-height:22px}#modal-container .modal-background .modal .modal-svg rect{stroke:#fff;stroke-width:2px;stroke-dasharray:778;stroke-dashoffset:778}@-webkit-keyframes fadeIn{0%{background:rgba(0,0,0,0)}100%{background:rgba(0,0,0,.7)}}@keyframes fadeIn{0%{background:rgba(0,0,0,0)}100%{background:rgba(0,0,0,.7)}}@-webkit-keyframes fadeOut{0%{background:rgba(0,0,0,.7)}100%{background:rgba(0,0,0,0)}}@keyframes fadeOut{0%{background:rgba(0,0,0,.7)}100%{background:rgba(0,0,0,0)}}@-webkit-keyframes scaleUp{0%{-webkit-transform:scale(.8) translateY(1000px);transform:scale(.8) translateY(1000px);opacity:0}100%{-webkit-transform:scale(1) translateY(0);transform:scale(1) translateY(0);opacity:1}}@keyframes scaleUp{0%{-webkit-transform:scale(.8) translateY(1000px);transform:scale(.8) translateY(1000px);opacity:0}100%{-webkit-transform:scale(1) translateY(0);transform:scale(1) translateY(0);opacity:1}}@-webkit-keyframes scaleBack{0%{-webkit-transform:scale(1);transform:scale(1)}100%{-webkit-transform:scale(.85);transform:scale(.85)}}@keyframes scaleBack{0%{-webkit-transform:scale(1);transform:scale(1)}100%{-webkit-transform:scale(.85);transform:scale(.85)}}@-webkit-keyframes quickScaleDown{0%,99.9%{-webkit-transform:scale(1);transform:scale(1)}100%{-webkit-transform:scale(0);transform:scale(0)}}@keyframes quickScaleDown{0%,99.9%{-webkit-transform:scale(1);transform:scale(1)}100%{-webkit-transform:scale(0);transform:scale(0)}}@-webkit-keyframes scaleDown{0%{-webkit-transform:scale(1) translateY(0);transform:scale(1) translateY(0);opacity:1}100%{-webkit-transform:scale(.8) translateY(1000px);transform:scale(.8) translateY(1000px);opacity:0}}@keyframes scaleDown{0%{-webkit-transform:scale(1) translateY(0);transform:scale(1) translateY(0);opacity:1}100%{-webkit-transform:scale(.8) translateY(1000px);transform:scale(.8) translateY(1000px);opacity:0}}@-webkit-keyframes scaleForward{0%{-webkit-transform:scale(.85);transform:scale(.85)}100%{-webkit-transform:scale(1);transform:scale(1)}}@keyframes scaleForward{0%{-webkit-transform:scale(.85);transform:scale(.85)}100%{-webkit-transform:scale(1);transform:scale(1)}}"]
            }] }
];
/** @nocollapse */
ModalComponent.ctorParameters = () => [];
ModalComponent.propDecorators = {
    modalOpen: [{ type: Input }]
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class OmnipresentWebLibModule {
}
OmnipresentWebLibModule.decorators = [
    { type: NgModule, args: [{
                declarations: [
                    OmnipresentWebLibComponent,
                    LoginComponent,
                    ViewImageComponent,
                    TableComponent,
                    ModalComponent
                ],
                imports: [
                    BrowserModule,
                    FormsModule,
                    NgxPaginationModule
                ],
                exports: [
                    OmnipresentWebLibComponent,
                    LoginComponent,
                    ViewImageComponent,
                    TableComponent,
                    ModalComponent
                ],
                schemas: [CUSTOM_ELEMENTS_SCHEMA],
                providers: [DatePipe]
            },] }
];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { OmnipresentWebLibService, OmnipresentWebLibComponent, OmnipresentWebLibModule, LoginComponent as ɵa, ModalComponent as ɵd, TableComponent as ɵc, ViewImageComponent as ɵb };

//# sourceMappingURL=omnipresent-omnipresent-web-lib.js.map